###############################################################################
#
# ǥեȤΥȥ졼ץ饰
#
###############################################################################
package Wiki::DefaultStorage;
use strict;

# ڡκǽϿե
$Wiki::DefaultStorage::MODTIME_FILE = "modtime.dat";

#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
	my $class = shift;
	my $wiki  = shift;
	my $self  = {};
	$self->{wiki}          = $wiki;
	$self->{exists_cache}  = {};
	$self->{modtime_cache} = undef;
	return bless $self,$class;
}

#==============================================================================
# ڡ
#==============================================================================
sub get_page {
	my $self = shift;
	my $page = shift;
	my $path = shift;
	
	my $dir = $self->{wiki}->config('data_dir');
	if($path ne ""){
		$dir = "$dir/$path";
	}
	
	my $content = "";
	my $filename = &Util::make_filename($dir,&Util::url_encode($page),"wiki");
	if(-e $filename){
		open(DATA,$filename) or die $!;
		binmode(DATA);
		while(<DATA>){
			$content = $content.$_;
		}
		close(DATA);
	}
	
	return $content;
}

#==============================================================================
# ڡ¸
#==============================================================================
sub save_page {
	my $self    = shift;
	my $page    = shift;
	my $content = shift;
	my $sage    = shift;
	my $wiki    = $self->{wiki};
	
	$content = '' if($content =~ /^[\r\n]+$/s); # added for opera
	
	# ڡ̾ȥڡƤ
	$page = Util::trim($page);
	$content =~ s/\r\n/\n/g;
	$content =~ s/\r/\n/g;
    
	# Хåå
	my $BACKUP = $self->get_page($page);
	if($BACKUP ne ""){
		open(DATA,">".&Util::make_filename($self->{wiki}->config('backup_dir'),&Util::url_encode($page),"bak")) or die $!;
		binmode(DATA);
		print DATA $BACKUP;
		close(DATA);
	}

	# Ͽե뤬ʤϺ
	unless(-e $wiki->config('config_dir')."/".$Wiki::DefaultStorage::MODTIME_FILE){
		my @list = $self->get_page_list();
		my $hash = {};
		foreach my $p (@list){
			$hash->{$p}=$self->get_last_modified($p);
		}
		&Util::save_config_hash($wiki,$Wiki::DefaultStorage::MODTIME_FILE,$hash);
	}
	
	# 񤭹
	if($content eq ""){
		unlink(&Util::make_filename($self->{wiki}->config('data_dir'),&Util::url_encode($page),"wiki"));
		# ϥХååץեĤ
		#unlink(&Util::make_filename($self->{wiki}->config('backup_dir'),&Util::url_encode($page),"bak"));
	} else {
		# 񤭤
		open(DATA,">".&Util::make_filename($self->{wiki}->config('data_dir'),&Util::url_encode($page),"wiki")) or die $!;
		binmode(DATA);
		print DATA $content;
		close(DATA);		
		# sageǤʤϹ򹹿
		if($sage != 1){
			my $modtime = &Util::load_config_hash($self->{wiki},$Wiki::DefaultStorage::MODTIME_FILE);
			$modtime->{$page} = time();
			&Util::save_config_hash($self->{wiki},$Wiki::DefaultStorage::MODTIME_FILE,$modtime);
		}
	}
}

#==============================================================================
# ڡΰ
#==============================================================================
sub get_page_list {
	my $self   = shift;
	my $args   = shift;
	my $wiki   = $self->{wiki};
	my $sort   = "name";
	my $permit = "all";
	my $max    = 0;
	
	# 
	if(defined($args)){
		if(defined($args->{-sort})){
			$sort = $args->{-sort};
		}
		if(defined($args->{-permit})){
			$permit = $args->{-permit};
		}
		if(defined($args->{-max})){
			$max = $args->{-max};
		}
	}
	
	# ڡΰ
	opendir(DIR,$self->{wiki}->config('data_dir')) or die $!;
	my ($entry,@list);
	while($entry = readdir(DIR)){
		my $name = &Util::url_decode(substr($entry,0,rindex($entry,".")));
		my $type = substr($entry,rindex($entry,"."));
		my $flag = 0;
		if($type eq ".wiki"){
			# ȸΤڡΤ
			if($permit eq "show"){
				if($wiki->can_show($name)){
					$flag = 1;
				}
				
			} elsif($permit eq "modify"){
				if($wiki->can_modify($name)){
					$flag = 1;
				}
				
			# ƤΥڡ
			} elsif($permit eq "all"){
				$flag = 1;
			
			# ʳξϥ顼
			} else {
				die "permitץλ꤬Ǥ";
			}
		}
		if($flag == 1){
			push(@list,$name);
		}
	}
	closedir(DIR);
	
	# ̾ǥ
	if($sort eq "name"){
		@list = sort { $a cmp $b } @list;
		
	# ʿˤ˥
	} elsif($sort eq "last_modified"){
		@list = sort {
			my $mod1 = $wiki->get_last_modified2($a);
			my $mod2 = $wiki->get_last_modified2($b);
			return $mod2 <=> $mod1;
		} @list;
	
	# ʳξϥ顼
	} else {
		die "sortץλ꤬Ǥ";
	}
	
	if($max==0){
		return @list;
		
	} else {
		my @result;
		for(my $i=0;$i<$max;$i++){
			push(@result,shift(@list));
		}
		return @result;
	}
}

#==============================================================================
# ڡκǽʪŪ
#==============================================================================
sub get_last_modified {
	my $self   = shift;
	my $page   = shift;
	my @status = stat(&Util::make_filename($self->{wiki}->config('data_dir'),&Util::url_encode($page),"wiki"));
	
	return $status[9];
}

#==============================================================================
# ڡκǽŪ
#==============================================================================
sub get_last_modified2 {
	my $self    = shift;
	my $page    = shift;
	my $modtime = $self->{modtime_cache};
	
	unless(defined($modtime)){
		$modtime = &Util::load_config_hash($self->{wiki},$Wiki::DefaultStorage::MODTIME_FILE);
		$self->{modtime_cache} = $modtime;
	}
	
	if(defined($modtime->{$page})){
		return $modtime->{$page};
	} else {
		return $self->get_last_modified($page);
	}
}

#===============================================================================
# ڡ¸ߤ뤫ɤĴ٤
#===============================================================================
sub page_exists {
	my $self = shift;
	my $page = shift;
	my $path = shift;
	
	if(defined($self->{exists_cache}->{"$path:$page"})){
		return $self->{exists_cache}->{"$path:$page"};
	}
	
	my $dir = $self->{wiki}->config('data_dir');
	if($path ne ""){
		$dir = "$dir/$path";
	}
	
	&Util::debug(&Util::make_filename($dir,&Util::url_encode($page),"wiki"));
	
	my $exists = (-e &Util::make_filename($dir,&Util::url_encode($page),"wiki"));
	$self->{exists_cache}->{"$path:$page"} = $exists;
	
	return $exists;
}

#==============================================================================
# Хååץפ(single|all)
#==============================================================================
sub backup_type {
	return "single";
}

#==============================================================================
# Хåå׻ΰޤ
#==============================================================================
sub get_backup_list {
	return undef;
}

#==============================================================================
# Хååפޤ
# backup_type=allξ(0)ꤷޤ
#==============================================================================
sub get_backup {
	my $self = shift;
	my $page = shift;
	my $content = "";
	
	my $filename = &Util::make_filename($self->{wiki}->config('backup_dir'),&Util::url_encode($page),"bak");
	if(-e $filename){
		open(DATA,$filename) or die $!;
		binmode(DATA);
		while(<DATA>){
			$content = $content.$_;
		}
		close(DATA);
	}
	
	return $content;
}

#==============================================================================
# ڡ뤷ޤ
#==============================================================================
sub freeze_page {
	my $self     = shift;
	my $pagename = shift;
	
	if(!$self->is_freeze($pagename)){
		open(DATA,">>".$self->{wiki}->config('log_dir')."/".$self->{wiki}->config('freeze_file')) or die $!;
		binmode(DATA);
		print DATA $pagename."\n";
		close(DATA);
		
		# 쥯Ȥפɡ
		push(@{$self->{freeze_list}},$pagename);
	}
}

#==============================================================================
# ڡޤ
#==============================================================================
sub un_freeze_page {
	my $self = shift;
	my $pagename = shift;
	
	if($self->is_freeze($pagename)){
		my $buf = "";
		open(DATA,$self->{wiki}->config('log_dir')."/".$self->{wiki}->config('freeze_file')) or die $!;
		while(<DATA>){
			chomp $_;
			if($pagename ne $_){
				$buf .= $_."\n";
			}
		}
		close(DATA);
		
		open(DATA,">".$self->{wiki}->config('log_dir')."/".$self->{wiki}->config('freeze_file')) or die $!;
		binmode(DATA);
		print DATA $buf;
		close(DATA);
		
		# 쥯Ȥפɡ
		@{$self->{freeze_list}} = grep(!/^\Q$pagename\E$/,@{$self->{freeze_list}});
	}
}

#==============================================================================
# ꥹȤ
#==============================================================================
sub get_freeze_list {
	my $self = shift;
	my $path = shift;
	
	if(!defined($path)){
		$path = "";
	}
	
	if(defined($self->{"$path:freeze_list"})){
		return @{$self->{"$path:freeze_list"}};
	}
	
	my $logdir = $self->{wiki}->config('log_dir');
	if($path ne ""){
		$logdir .= "/$path";
	}
	
	my @list;
	if(!-e "$logdir/".$self->{wiki}->config('freeze_file')){
		return @list;
	}
	
	open(DATA,"$logdir/".$self->{wiki}->config('freeze_file')) or die $!;
	while(<DATA>){
		chomp $_;
		push @list,$_;
	}
	close(DATA);
	
	$self->{"$path:freeze_list"} = \@list;
	return @list;
}

#==============================================================================
# Ϥڡ椫ɤ٤ޤ
#==============================================================================
sub is_freeze {
	my $self     = shift;
	my $pagename = shift;
	my $path     = shift;
	
	foreach my $freeze_page ($self->get_freeze_list($path)){
		if($freeze_page eq $pagename){
			return 1;
		}
	}
	
	return 0;
}

#==============================================================================
# ڡλȥ٥ꤷޤ
# 0˸ 1桼˸ 2Ԥ˸
#==============================================================================
sub set_page_level {
	my $self  = shift;
	my $page  = shift;
	my $level = shift;
	
	my $all = &Util::load_config_hash($self->{wiki},"showlevel.log");
	$all->{$page} = $level;
	&Util::save_config_hash($self->{wiki},"showlevel.log",$all);
}

#==============================================================================
# ڡλȥ٥ޤ
# 0˸ 1桼˸ 2Ԥ˸
#==============================================================================
sub get_page_level {
	my $self = shift;
	my $page = shift;
	my $path = shift;
	
	if(!defined($path)){
		$path = "";
	}
	
	unless(defined($self->{"$path:show_level"})){
		# config_dir򺹤ؤƼ¹
		my $configdir = $self->{wiki}->config('config_dir');
		if($path ne ""){
			$self->{wiki}->config('config_dir',"$configdir/$path");
		}
		
		$self->{"$path:show_level"} = &Util::load_config_hash($self->{wiki},"showlevel.log");
		
		# config_dir򸵤᤹
		$self->{wiki}->config('config_dir,$configdir');
	}
	
	if(defined($page)){
		if(defined($self->{"$path:show_level"}->{$page})){
			return $self->{"$path:show_level"}->{$page};
		} else {
			return 0;
		}
	} else {
		return $self->{"$path:show_level"};
	}
}

1;
